# -*- coding: utf-8 -*-
"""
Created on Sun May  6 13:45:47 2018

@author: Michael Stadlhofer 01530415
"""

import numpy as np
from mo_functions import atom, molecule, degree



'''defining molecules'''
# H2+    
H1 = atom([[1,0,0]], 1, [-0.76e-10/2.0,0,0], symbol = "H1")
H2 = atom([[1,0,0]], 1, [0.76e-10/2.0,0,0], symbol = "H2")
H2plus = molecule([H1, H2], "H2+")


# H2O
alpha = 90 # angle between symmetry axis of the molecule in the x,y plane 
           # and the x axis
O = atom([[1,0,0],[2,0,0], [2,1,-1], [2,1,1], [2,1,0]], 8, [0,0,0], symbol = "O")
H1 = atom([[1,0,0]], 1, 0.097e-9*np.asarray([np.cos((alpha+52)*degree), np.sin((alpha+52)*degree),0]), symbol = "H1")
H2 = atom([[1,0,0]], 1, 0.097e-9*np.asarray([np.cos((alpha -52)*degree), np.sin((alpha - 52)*degree),0]), symbol = "H2")
H2O = molecule([O, H1, H2], "H2O")


''' solving the roothan equations for a molecule'''
# enter the molecule to be solved here
mol = H2O

# solving the roothaan equations
mol.solve()

# hamiltonian matrix
H = mol.H

# solution to the eigenvalue problem
eig = mol.sol


''' saving the molecule (placement of atoms and orbitals)
and the solution to the roothaan equations'''
mol.save_molecule_data()


''' testing '''
#import matplotlib.pyplot as plt
#relative error of the expectation value <psi|H|psi>
# for different upper integration limits rmax
#
#orb_idx = 1
#
#Atom= O
#e_rel = lambda r: (mol.braket(Atom.orbitals[orb_idx], Atom.orbitals[orb_idx], "H", rmax= r) - Atom.orbitals[orb_idx].E)/Atom.orbitals[orb_idx].E
#
#
#R = np.linspace(0.1*a0, 100*a0, 10)
#err = [e_rel(r) for r in R]
#
#
#plt.plot(R/a0, np.abs(np.asarray(err)))
